﻿
using System.Numerics;
using System.Runtime.CompilerServices;

{
    int n = -2020987651;

    OutputBitText("[n] \t\t ", n);
    OutputBitText("[n] >>> 4 ==> \t ", n >>> 4);
    OutputBitText("[n] >> 4 ==> \t ", n >> 4);

    C c = new C();
    C d = c >>> 4;
    C e = c >>> 0.4f;
}


if (args.Length == 1)
{
    uint un = 2320987651;
    int n = 2020987651;

    OutputBitTextU("[un] \t\t\t ", un);
    OutputBitTextU("[n] \t\t\t ", (uint)n);
    Console.WriteLine();

    OutputBitTextU("[TripleRightShift] 4 ==> ", TripleRightShift(un, 4));
    OutputBitTextU("[un] >>> 4 ==> \t\t ", un >>> 4);
    OutputBitTextU("[un] >> 4 ==> \t\t ", un >> 4);
    Console.WriteLine();

    OutputBitTextU("[TripleRightShift] 4 ==> ", TripleRightShift((uint)n, 4));
    OutputBitText("[n] >>> 4 ==> \t\t ", n >>> 4);
    OutputBitText("[n] >>. 4 ==> \t\t ", (int)((uint)n >> 4));
    OutputBitText("[n] >> 4 ==> \t\t ", n >> 4);
    Console.WriteLine();

    OutputBitTextU("[TripleRightShift] 4 ==> ", TripleRightShift((uint)-n, 4));
    OutputBitText("[-n] >>> 4 ==> \t\t ", -n >>> 4);
    OutputBitText("[-n] >>. 4 ==> \t\t ", (int)((uint)(-(uint)n) >> 4));
    OutputBitText("[-n] >> 4 ==> \t\t ", -n >> 4);
}

uint TripleRightShift(uint number, int shift)
{
    return ((uint)number >> shift);
}

void OutputBitTextU(string text, uint n)
{
    Console.WriteLine(text + " " + Convert.ToString(n, 2).PadLeft(32, '0'));
}

void OutputBitText(string text, int n)
{
    Console.WriteLine(text + " " + Convert.ToString(n, 2).PadLeft(32, '0'));
}

class C
{
    public static C operator >>>(C c, int n)
    {
        Console.WriteLine("right shift operator called with " + n);

        return c;
    }

    public static C operator >>>(C c, float n)
    {
        Console.WriteLine("right shift operator called with " + n);

        return c;
    }
}